package me.Demon.DemonPlayerMail.Listener;

import me.Demon.DemonPlayerMail.Api.DMailAPI;
import me.Demon.DemonPlayerMail.Main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class toMail implements Listener {

    public static String inv_title = "§m§a§i§l§r管理发件箱 - ";

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        Inventory inv = e.getInventory();
        if (e.getView().getTitle().contains(inv_title)) {
            if (e.getRawSlot() >= 36 && e.getRawSlot() <= 44) {
                e.setCancelled(true);
                if (e.getRawSlot() == 40) {
                    String playName = e.getView().getTitle().replace(inv_title, "");
                    p.playSound(p.getLocation(), Sound.ENTITY_PLAYER_LEVELUP, 1, 2);
                    //清空玩家邮箱数据
                    DMailAPI.resetMailData(playName);
                    int amount = 0;
                    for (int i = 0; i < 36; i++) {
                        ItemStack item = inv.getItem(i);
                        if (!Main.itemIsNull(item)) {
                            amount = amount + item.getAmount();
                            DMailAPI.GiveItem(playName, item);
                            Main.SaveLogAndSendLog(playName, item, "新增");
                        }
                    }
                    if (amount >= 1) {
                        p.closeInventory();
                        DMailAPI.setMailAmount(playName, amount);
                        p.sendMessage(Main.prefix + "成功发送物品到§6" + playName + "§f的游戏邮箱中.");
                    } else {
                        p.closeInventory();
                        p.sendMessage(Main.prefix + "你没有可发送的物品.");
                    }
                }
            }
        }
    }

    public static void OpenGui(Player p, String playName) {
        Inventory inv = Bukkit.createInventory(null, 45, inv_title + playName);
        YamlConfiguration yml = (YamlConfiguration) Main.mailDataG;
        if (yml.getString("MailData." + playName) != null) {
            for (String keyId : yml.getConfigurationSection("MailData." + playName).getKeys(false)) {
                if (!keyId.equalsIgnoreCase("amount")) {
                    ItemStack item = yml.getItemStack("MailData." + playName + "." + keyId);
                    inv.addItem(item);
                }
            }
        }
        for (int i = 36; i < 45; i++) {
            inv.setItem(i, glass());
        }
        inv.setItem(40, sendOK());
        p.openInventory(inv);
    }


    public static ItemStack glass() {
        ItemStack item = new ItemStack(160, 1, (short) 15);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7[§a■□■§7]");
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack sendOK() {
        ItemStack item = new ItemStack(Material.SLIME_BALL);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l确认发货");
        List<String> lore = new ArrayList<>();
        lore.add("§7点击发货");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
